-- scope stuff
gearquipper = gearquipper or {};
local c = gearquipper;

local SLOT_AMMO = "AmmoSlot";				--  0
local SLOT_HEAD = "HeadSlot";				--  1
local SLOT_NECK = "NeckSlot";				--  2
local SLOT_SHOULDER = "ShoulderSlot";		--  3
local SLOT_SHIRT = "ShirtSlot";				--  4
local SLOT_CHEST = "ChestSlot";				--  5
local SLOT_WAIST = "WaistSlot";				--  6
local SLOT_LEGS = "LegsSlot";				--  7
local SLOT_FEET = "FeetSlot";				--  8
local SLOT_WRIST = "WristSlot";				--  9
local SLOT_HANDS = "HandsSlot";				-- 10
local SLOT_FINGER1 = "Finger0Slot";			-- 11
local SLOT_FINGER2 = "Finger1Slot";			-- 12
local SLOT_TRINKET1 = "Trinket0Slot";		-- 13
local SLOT_TRINKET2 = "Trinket1Slot";		-- 14
local SLOT_BACK = "BackSlot";				-- 15
local SLOT_MAINHAND = "MainHandSlot";		-- 16
local SLOT_OFFHAND = "SecondaryHandSlot";	-- 17
local SLOT_RANGED = "RangedSlot";			-- 18
local SLOT_TABARD = "TabardSlot";			-- 19

local slotInfo = {
	[INVSLOT_AMMO] = SLOT_AMMO,
	[INVSLOT_HEAD] = SLOT_HEAD,
	[INVSLOT_NECK] = SLOT_NECK,
	[INVSLOT_SHOULDER] = SLOT_SHOULDER,
	[INVSLOT_BODY] = SLOT_SHIRT,
	[INVSLOT_CHEST] = SLOT_CHEST,
	[INVSLOT_WAIST] = SLOT_WAIST,
	[INVSLOT_LEGS] = SLOT_LEGS,
	[INVSLOT_FEET] = SLOT_FEET,
	[INVSLOT_WRIST] = SLOT_WRIST,
	[INVSLOT_HAND] = SLOT_HANDS,
	[INVSLOT_FINGER1] = SLOT_FINGER1,
	[INVSLOT_FINGER2] = SLOT_FINGER2,
	[INVSLOT_TRINKET1] = SLOT_TRINKET1,
	[INVSLOT_TRINKET2] = SLOT_TRINKET2,
	[INVSLOT_BACK] = SLOT_BACK,
	[INVSLOT_MAINHAND] = SLOT_MAINHAND,
	[INVSLOT_OFFHAND] = SLOT_OFFHAND,
	[INVSLOT_RANGED] = SLOT_RANGED,
	[INVSLOT_TABARD] = SLOT_TABARD
};

function c:GetSlotInfo()
	return slotInfo;
end

local slotSwitchOrder;
function c:GetSlotSwitchOrder()
	if not slotSwitchOrder then
		slotSwitchOrder = {};
		table.insert(slotSwitchOrder, INVSLOT_MAINHAND);
		table.insert(slotSwitchOrder, INVSLOT_OFFHAND);
		table.insert(slotSwitchOrder, INVSLOT_RANGED);

		for i = 0, 19 do
			if not tContains(slotSwitchOrder, i) then
				table.insert(slotSwitchOrder, i);
			end
		end
	end
	return slotSwitchOrder;
end

function c:GetSlotId(slotName)
	for slotId, name in pairs(c:GetSlotInfo()) do
		if name == slotName then
			return slotId;
		end
	end
end

local displaySlotNames = {
	[0] = INVTYPE_AMMO,
	[1] = INVTYPE_HEAD,
	[2] = INVTYPE_NECK,
	[3] = INVTYPE_SHOULDER,
	[4] = INVTYPE_BODY,
	[5] = INVTYPE_CHEST,
	[6] = INVTYPE_WAIST,
	[7] = INVTYPE_LEGS,
	[8] = INVTYPE_FEET,
	[9] = INVTYPE_WRIST,
	[10] = INVTYPE_HAND,
	[11] = INVTYPE_FINGER .. " 1",
	[12] = INVTYPE_FINGER .. " 2",
	[13] = INVTYPE_TRINKET .. " 1",
	[14] = INVTYPE_TRINKET .. " 2",
	[15] = INVTYPE_CLOAK,
	[16] = INVTYPE_WEAPONMAINHAND,
	[17] = INVTYPE_WEAPONOFFHAND,
	[18] = INVTYPE_RANGED,
	[19] = INVTYPE_ROBE
};

function c:GetDisplaySlotName(slotId)
	if displaySlotNames[slotId] then
		return displaySlotNames[slotId];
	end
end

c.EVENT_MOUNT = "EVENT_MOUNT";
c.EVENT_DISMOUNT = "EVENT_DISMOUNT";

c.EVENT_STEALTH = "EVENT_STEALTH";
c.EVENT_UNSTEALTH = "EVENT_UNSTEALTH";

local events, eventNamesSorted;
function c:GetEvents()
	if not events then
		events = {
			[c.EVENT_MOUNT] = c:GetText("on mount"),
			[c.EVENT_DISMOUNT] = c:GetText("on dismount"),
			[c.EVENT_STEALTH] = c:GetText("on entering stealth"),
			[c.EVENT_UNSTEALTH] = c:GetText("on leaving stealth"),
			["z1"] = c:GetText("|cffffffffPlease suggest more events at:"), -- todo: remove
			["z2"] = c:GetText("|cffffffffcurseforge.com/wow/addons/gearquipper") -- todo: remove
		};
	end
	return events;
end

function c:GetEventNamesSorted()
	if not eventNamesSorted then
		eventNamesSorted = {
			c.EVENT_MOUNT,
			c.EVENT_DISMOUNT,
			c.EVENT_STEALTH,
			c.EVENT_UNSTEALTH
		};
		--eventNamesSorted = {};
		--local tmp = {};
		--for eventName, eventDisplayName in pairs(c:GetEvents()) do
		--	if not c:StartsWith(eventName, "z") then -- todo: remove
		--		table.insert(tmp, eventDisplayName);
		--	end
		--end

		--table.sort(tmp); --, function(a, b) return a > b end); -- descending
		--for index, sortedDisplayName in ipairs(tmp) do
		--	for eventName, eventDisplayName in pairs(c:GetEvents()) do
		--		if sortedDisplayName == eventDisplayName then
		--			table.insert(eventNamesSorted, eventName);
		--			break;
		--		end
		--	end
		--end
	end
	return eventNamesSorted;
end